clear all;


%%%%%%%%%%%%%%  Read Data   %%%%%%%%%%%%%%%%

filename='rollhistorybk2deg7.xlsx';
M = xlsread(filename,1);
time_s=M(:,1);
roll_exp=M(:,2)-mean(M(:,2));

q0 = [roll_exp(1);0];         % Initial Condition (vector)
h=0.02;                   % Time step
t = 0:h:14; .
%-------------------------------------------------------------------
I44=2;               %Only the sum of I44+A44 that matters, not correct 
A44=.33;             %values for each one
C44=17.3;            %Restoring coefficient assumed constant
%-------------------------------------------------------------------
p1=0.072;  %damping values obtained from the Faltinsen fit
p2=0.021;
%-------------------------------------------------------------------
%dimensionalized damping coefficients
B44=p1*(I44+A44);
B44q=p2*(I44+A44);

qstar = zeros(2,length(t));  % Preallocate array (good coding practice)

Tr=2*pi*((I44+A44)/(C44))^0.5;

qstar(:,1) = q0;  
for i=1:(length(t)-1)

    
k11=qstar(2,i);
k12=-C44/(I44+A44)*qstar(1,i)-B44/(I44+A44)*qstar(2,i)-B44q/(I44+A44)...
    *qstar(2,i)*abs(qstar(2,i));
    

q1=qstar(1,i)+h/2*k11;
q2=qstar(2,i)+h/2*k12;


k21=q2;
k22=-C44/(I44+A44)*q1-B44/(I44+A44)*q2-B44q/(I44+A44)*q2*abs(q2);


qstar(1,i+1)=qstar(1,i)+h*k21;
qstar(2,i+1)=qstar(2,i)+h*k22;



end

plot(time_s,roll_exp,t,qstar(1,:));        % ystar = first row of qstar
legend('CFD','Analytic approximation')
xlim([0 10])
xlabel ('Time, [s]')
ylabel('$\theta ^\circ$',  'interpreter','latex')
ylim([-10 10])
grid on